VERSION 5.00
Begin VB.Form frmSlctClnt 
   Appearance      =   0  'Flat
   BackColor       =   &H80000005&
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Select An Account Holder"
   ClientHeight    =   2775
   ClientLeft      =   2670
   ClientTop       =   2205
   ClientWidth     =   6405
   ControlBox      =   0   'False
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2775
   ScaleWidth      =   6405
   Begin VB.CommandButton cmdAdd 
      Caption         =   "Add New"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   330
      Left            =   3750
      TabIndex        =   9
      ToolTipText     =   "Click to add a new client"
      Top             =   2250
      Width           =   1000
   End
   Begin VB.CommandButton cmdAccept 
      Caption         =   "Accept"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   330
      Left            =   1500
      TabIndex        =   8
      ToolTipText     =   "Click to add the selected client as a new account holder"
      Top             =   2250
      Width           =   1000
   End
   Begin VB.Frame fraNomiName 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00C00000&
      Height          =   1650
      Left            =   400
      TabIndex        =   0
      Top             =   500
      Width           =   5500
      Begin VB.CheckBox chkAcctHldr 
         Appearance      =   0  'Flat
         BackColor       =   &H80000005&
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         ForeColor       =   &H80000008&
         Height          =   200
         Left            =   390
         TabIndex        =   3
         ToolTipText     =   "Select when the account holder is an existing client"
         Top             =   500
         Width           =   200
      End
      Begin VB.ComboBox cmbAcctType 
         Appearance      =   0  'Flat
         CausesValidation=   0   'False
         Height          =   315
         ItemData        =   "frmSlctClnt.frx":0000
         Left            =   1620
         List            =   "frmSlctClnt.frx":000A
         TabIndex        =   2
         Text            =   "SB"
         ToolTipText     =   "Select the type of account for the account held by the existing client"
         Top             =   500
         Width           =   600
      End
      Begin VB.ComboBox cmbAcctNo 
         Appearance      =   0  'Flat
         Height          =   315
         ItemData        =   "frmSlctClnt.frx":0016
         Left            =   3840
         List            =   "frmSlctClnt.frx":0018
         TabIndex        =   1
         ToolTipText     =   "Select the account number held by the existing client"
         Top             =   500
         Width           =   1240
      End
      Begin VB.ComboBox cmbName 
         Height          =   315
         Left            =   1080
         TabIndex        =   4
         ToolTipText     =   "Select the name of the client, as a holder for an account"
         Top             =   1035
         Width           =   4000
      End
      Begin VB.Label lblHldrOf 
         Appearance      =   0  'Flat
         BackColor       =   &H80000005&
         Caption         =   "Holder Of"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         ForeColor       =   &H80000008&
         Height          =   195
         Left            =   675
         TabIndex        =   7
         ToolTipText     =   "Selected if the account holder is an existing client"
         Top             =   500
         Width           =   900
      End
      Begin VB.Label lblName 
         Appearance      =   0  'Flat
         BackColor       =   &H80000005&
         Caption         =   "Name :"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         ForeColor       =   &H80000008&
         Height          =   195
         Left            =   390
         TabIndex        =   6
         ToolTipText     =   "Selected name of the client, as a holder for an account"
         Top             =   1035
         Width           =   630
      End
      Begin VB.Label lblAcctNo 
         Appearance      =   0  'Flat
         BackColor       =   &H80000005&
         Caption         =   "Account Number :"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         ForeColor       =   &H80000008&
         Height          =   195
         Left            =   2280
         TabIndex        =   5
         ToolTipText     =   "Seleted account number held by the existing client"
         Top             =   500
         Width           =   1545
      End
   End
End
Attribute VB_Name = "frmSlctClnt"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'Declaring variables for later use
Dim mAcctType, mAcctNo, mClntName, mSqlStr As String

'*******************************************************************
'******** FUNCTIONALITY FOR THE FORM SPECIFIC EVENTS BEGINS ********
'The Form_Load() is called to load a form to add a client as an account holder
Public Sub Form_Load()
'Disabling some data capture objects
    cmbAcctType.Enabled = False
    cmbAcctNo.Enabled = False
'Creating a SQL query string to retrieve records from the Client's master table
    mSqlStr = "SELECT ClientId FROM Clnt_Mstr"
'Storing the value returned by PopNameCmd while populating the combo box listing client's name
    mClntName = PopNameCmb(mSqlStr, "Clnt_Mstr", cmbName)
End Sub
'********* FUNCTIONALITY FOR THE FORM SPECIFIC EVENTS ENDS *********
'*******************************************************************


'*******************************************************************
'******* FUNCTIONALITY OF THE FORM's CHECKBOX BUTTONS BEGINS *******
'The chkAcctHldr_Click() is called when the option select an existing client is clicked
Public Sub chkAcctHldr_Click()
'Checking if the option for the cash transaction is checked
    If chkAcctHldr.Value = 1 Then
    'Setting initial values into variables local to the form
        mAcctType = ""
    'Enabling some data capture objects
        cmbAcctType.Enabled = True
        cmbAcctNo.Enabled = True
    'Calling cmbAcctType_Click to refresh the combo box listing account type
        Call cmbAcctType_Click
    Else
    'Disabling some data capture objects
        cmbAcctType.Enabled = False
        cmbAcctNo.Enabled = False
    'Creating a SQL query string to retrieve records from the Client's master table
        mSqlStr = "SELECT ClientId FROM Clnt_Mstr"
    'Storing the value returned by PopNameCmd while populating the combo box listing client's name
        mClntName = PopNameCmb(mSqlStr, "Clnt_Mstr", cmbName)
    End If
End Sub
'******** FUNCTIONALITY OF THE FORM's CHECKBOX BUTTONS ENDS ********
'*******************************************************************


'*******************************************************************
'******** FUNCTIONALITY OF THE FORM's OPTION BUTTONS BEGINS ********
'The cmbAcctType_Click() is called when the combo box listing account types get clicked
Public Sub cmbAcctType_Click()
'Checking if the user has selected a different account type
    If cmbAcctType.Text <> mAcctType Then
    'Storing the value returned by PopNoCmd while populating the combo box listing account numbers
        mAcctType = PopNoCmb(cmbAcctType.Text, cmbAcctNo)
    'Clearing the variable holding the last selection for an account numbers
        mAcctNo = ""
    'Calling cmbAcctNo_Click to refresh the combo box listing account numbers
        Call cmbAcctNo_Click
    End If
End Sub

'The cmbAcctNo_Click() is called when the combo box listing account numbers get clicked
Public Sub cmbAcctNo_Click()
'Checking if the user has selected a different account type
    If cmbAcctNo.Text <> mAcctNo Then
    'Creating a SQL query string to retrieve records from the Account master table
        mSqlStr = "SELECT ClientId1, ClientId2, ClientId3 FROM Acct_Mstr Where AcctNo = " & cmbAcctNo.Text
    'Storing the value returned by PopNameCmd while populating the combo box listing client's name
        mClntName = PopNameCmb(mSqlStr, "Clnt_Mstr", cmbName)
    End If
End Sub
'********* FUNCTIONALITY OF THE FORM's OPTION BUTTONS ENDS *********
'*******************************************************************


'*******************************************************************
'******** FUNCTIONALITY FOR THE FORM BUTTON's EVENTS BEGINS ********
'The cmdAdd_Click() is called when the button to add a new client is clicked
Public Sub cmdAdd_Click()
'Storing a new SQL query to retrieve records from the Client's master recordset
    gClntSql = "SELECT * FROM Clnt_Mstr Where ClientId = 0"
'Calling Unload to terminate the form's functionality
    Unload frmSlctClnt
'Calling LoadChild to load the Client Master child form by passing a parameter of the Form object type
    Call LoadChild(frmClntMstr)
End Sub

'The cmdAccept_Click() is called when the button 'OK' is clicked
Public Sub cmdAccept_Click()
'Calling ReturnId to pass a client's name, to be displayed in a data entry form field
    Call ReturnId(cmbName.Text, gObjId)
'Calling Unload to terminate the form's functionality
    Unload frmSlctClnt
End Sub
'********* FUNCTIONALITY FOR THE FORM BUTTON's EVENTS ENDS *********
'*******************************************************************
