Attribute VB_Name = "modBnkSys"
Option Explicit
'Declaring variables for later use
Public gRprtType, gObjId As String
Public gFrmName1, gFrmName2, gFrmName3 As String
Public gFrmRs1, gFrmRs2, gFrmRs3 As String
Public gAcctSql, gClntSql, gEmpSql, gTransSql, gTemp1Sql As String
Public gMsgResponse As Integer
Dim mStr, mStrCheck1 As String
Dim mStrLen, mPosition As Integer

'Declaring Connection object variable
Public gConnect As ADODB.Connection

'Declaring Recordset object variable
Public gAcctRs, gClntRs, gEmpRs, gTransRs As ADODB.Recordset
Public gChqRs, gCshRs, gContRs, gTemp1Rs, gTemp2Rs, gTemp3Rs As ADODB.Recordset

'*******************************************************************
'*********** APPLICATION's DATABASE CONNECTIVITY BEGINS ************
'The Connect2DB() is called to open a database connection
Public Sub Connect2DB()
'Initializing an ADODB Connection object
    Set gConnect = New ADODB.Connection
'Binding the connection object's Provider attribute to an Access database through an OLEDB provider
    gConnect.Provider = "Microsoft.Jet.OLEDB.4.0; Data Source = " & App.Path & "\Database\Bank.mdb"
'Opening the connection with the database
    gConnect.Open
'Initialising the ADODB's Recordset objects
    Set gAcctRs = New ADODB.Recordset
    Set gClntRs = New ADODB.Recordset
    Set gEmpRs = New ADODB.Recordset
    Set gTransRs = New ADODB.Recordset
    Set gChqRs = New ADODB.Recordset
    Set gCshRs = New ADODB.Recordset
    Set gContRs = New ADODB.Recordset
    Set gTemp1Rs = New ADODB.Recordset
    Set gTemp2Rs = New ADODB.Recordset
    Set gTemp3Rs = New ADODB.Recordset
End Sub
'************ APPLICATION's DATABASE CONNECTIVITY ENDS *************
'*******************************************************************


'*******************************************************************
'******** FUNCTIONALITY FOR THE FORM SPECIFIC EVENTS BEGINS ********
'The LoadChild() is called to load a child form passed as a parameter
Public Sub LoadChild(frmName As Form)
'Resetting the Caption attribute for the MDI's sub menu option 'Exit'
    frmMain.mnuExit.Caption = "&Close"
'Resetting the ToolTipText attribute for MDI's toolbar button 'Exit'
    frmMain.cmdExit.ToolTipText = "Click to close the form"
    gFrmName3 = gFrmName2
    gFrmName2 = gFrmName1
'Checking if the global variable 'gFrmName1' is not empty
    If gFrmName1 <> "" Then
    'Calling DisableFrmOpt() to disable the MDI's sub menu options used to open a child form
        Call DisableFrmOpt
    End If
'Loading the child form passed as a parameter
    Load frmName
End Sub

'The GetActvFrm() is called to returns a form object for the string passed as a parameter
Public Function GetActvFrm(ByVal mFrmName As String) As Form
'Use the variable 'mFrmName' with the Select Case statement to returning an appropriate the data entry form
    Select Case mFrmName
    Case Is = "Account" 'If the variable holds 'Account'
    'Returning the child form for Account Master
        Set GetActvFrm = frmAcctMstr
    Case Is = "Client" 'If the variable holds 'Client'
    'Returning the child form for Client Master
        Set GetActvFrm = frmClntMstr
    Case Is = "Employee" 'If the variable holds 'Employee'
    'Returning the child form for Employee Master
        Set GetActvFrm = frmEmpMstr
    Case Is = "Transaction" 'If the variable holds 'Transaction'
    'Returning the child form for Transaction Master
        Set GetActvFrm = frmTransMstr
    Case Is = "Report" 'If the variable holds 'Pass Book'
    'Returning the child form for the Pass Book
        Set GetActvFrm = frmShowRprt
    Case Is = "Open Form" 'If the variable holds 'Open Form'
    'Returning the child form for selecting a master form
        Set GetActvFrm = frmOpenFrm
    Case Is = "" 'If the variable is empty
    'Returning the MDI form to close the application
        Set GetActvFrm = frmMain
    End Select
End Function

'The ResetMDI() is called to reset a sequence used for global variables (holding names for activated the child form(s) and recordset object) and object attributes belonging to the MDI form
Public Sub ResetMDI()
    gFrmName1 = gFrmName2
    gFrmName2 = gFrmName3
    gFrmName3 = ""
    gFrmRs1 = gFrmRs2
    gFrmRs2 = gFrmRs3
    gFrmRs3 = ""
'Checking if the variable 'gFrmName1' holds a value other than the string 'frmMain'
    If gFrmName1 = "" Then
    'Resetting the Caption attribute for the menu option 'Exit' under the menubar option 'Form'
        frmMain.mnuExit.Caption = "&Exit"
    'Resetting the ToolTipText attribute for MDI's toolbar button 'Exit'
        frmMain.cmdExit.ToolTipText = "Click to exit the application"
    'Calling MDI's SetQry to reset SQL queries stored into the global variables
        Call frmMain.SetQry
    'Calling MDI's OptStatus to determine the state of the MDI's menubar and toolbar options when all data entry forms are inactive
        Call frmMain.OptStatus
    End If
End Sub
'********* FUNCTIONALITY FOR THE FORM SPECIFIC EVENTS ENDS *********
'*******************************************************************


'*******************************************************************
'********** FUNCTIONALITY FOR FORM's DATA VIEWING BEGINS ***********
'The VuMstrRecd() is called to view a Master record
Public Sub VuMstrRecd(mFrmRs As ADODB.Recordset)
'Checking if the recordset passed as a parameter is empty
    If mFrmRs.RecordCount > 0 Then
    'Calling ChngMstr to determine the state of the MDI's menubar and toolbar options such as to allow all data manipulation and navigation operations
        Call ChngMstr
    'Calling PopFrmFlds to populate the active form's fields with data from the active recordset
        Call GetActvFrm(gFrmName1).PopFrmFlds
    Else
    'Disabling MDI's View options
        frmMain.mnuView.Enabled = False
        frmMain.cmdView.Enabled = False
    'Checking if the global variable 'gFrmName1' refers to the Client master data entry screen
        If gFrmName1 = "Client" Then
        'Calling Client Master's DisableDtls to disable data manipulation in the U.I.'s Detail section
            Call frmClntMstr.DisableDtls
        End If
    'Prompt the user about no records being available
        gMsgResponse = MsgBox("No " & gFrmName1 & " Information exists!!   " & vbCrLf & vbCrLf & _
            "Do you want to insert such information?", vbYesNo + vbDefaultButton1 + vbInformation, "Please Note")
    'Checking if the user chose to Insert a record.
        If gMsgResponse = 6 Then
        'Calling InstMstrRecd to insert a record
            Call GetActvFrm(gFrmName1).InstMstrRecd
        Else
        'Unloading the active form returned by the function 'GetActvFrm' by passing the parameter string which refers to that form
            Unload GetActvFrm(gFrmName1)
        End If
    End If
End Sub
'*********** FUNCTIONALITY FOR FORM's DATA VIEWING ENDS ************
'*******************************************************************


'*******************************************************************
'**************** DATA PRINTING FOR THE FORM BEGINS ****************
'The PrntMstrRecd() is called to Prints the record displayed on the UI
Public Sub PrntMstrRecd(mFrmRs As ADODB.Recordset)
'Message indicating that the printer is not available
    MsgBox "Printer not available!!", vbOKOnly
    If gFrmName1 = "Account" Then
        rptAccHolderInfo.WindowState = vbMaximized
        rptAccHolderInfo.Show vbModal
    End If
End Sub
'***************** DATA PRINTING FOR THE FORM ENDS *****************
'*******************************************************************


'*******************************************************************
'************ FUNCTIONALITY FOR DATA NAVIGATION BEGINS *************
'The VuFrstMstr() is called to navigate to the FIRST record in the recordset passed as parameter
Public Sub VuFrstMstr(mFrmRs As ADODB.Recordset)
'Placing the active recordset's cursor to the FIRST record
    mFrmRs.MoveFirst
'Calling PopFrmFlds to populate the active form's fields with data from the active recordset
    Call GetActvFrm(gFrmName1).PopFrmFlds
End Sub

'The VuPrevMstr() is called to navigates to the PREVIOUS record in the recordset passed as parameter
Public Sub VuPrevMstr(mFrmRs As ADODB.Recordset)
'Placing the active recordset's cursor to the PREVIOUS record
    mFrmRs.MovePrevious
'Checking if the recordset's cursor has moved beyond the FIRST record in the recordset
    If mFrmRs.BOF Then
        MsgBox "You are on the first record!!", vbExclamation, "PLEASE NOTE"
    'Placing the active recordset's cursor to the First record
        mFrmRs.MoveNext
    Else
    'Calling PopFrmFlds to populate the active form's fields with data from the active recordset
        Call GetActvFrm(gFrmName1).PopFrmFlds
    End If
End Sub

'The VuNextMstr() is called to navigate to the NEXT record in the recordset passed as parameter
Public Sub VuNextMstr(mFrmRs As ADODB.Recordset)
'Placing the active recordset's cursor to the Next record
    mFrmRs.MoveNext
'Checking if the recordset's cursor has moved beyond the LAST record in the recordset
    If mFrmRs.EOF Then
        MsgBox "You are on the last record!!", vbExclamation, "PLEASE NOTE"
    'Placing the active recordset's cursor to the Previous record
        mFrmRs.MovePrevious
    Else
    'Calling PopFrmFlds to populate the active form's fields with data from the active recordset
        Call GetActvFrm(gFrmName1).PopFrmFlds
    End If
End Sub

'The VuLastMstr() is called to navigate to the LAST record in the recordset passed as parameter
Public Sub VuLastMstr(mFrmRs As ADODB.Recordset)
'Placing the active recordset's cursor to the LAST record
    mFrmRs.MoveLast
'Calling PopFrmFlds to populate the active form's fields with data from the active recordset
    Call GetActvFrm(gFrmName1).PopFrmFlds
End Sub
'************* FUNCTIONALITY FOR DATA NAVIGATION ENDS **************
'*******************************************************************


'*******************************************************************
'********* FUNCTIONALITY FOR FORM FIELD VALIDATIONS BEGINS *********
'The CharFound() is called to validate whether a specific character in the field value passed as a parameter
Public Function CharFound(mText As String, mChar As String) As Boolean
'Retrieving the position of the specific character in the parameter string
    mPosition = InStr(1, mText, mChar, vbTextCompare)
'Checking the value of the variable 'mPosition' after scanning the value held in the parameter 'mText' of the specific character held in parameter 'mChar' and returning an appropriate Boolean value
    If mPosition > 0 Then
        CharFound = True
    Else
        CharFound = False
    End If
End Function

'The MinLen() is called to validate the length of the field value passed as a parameter
Public Function MinLen(mText As String, mMinLen As Integer) As Boolean
'Removing any spaces from the string passed as a parameter
    mText = Trim(mText)
'Retrieving the length of the string passed as a parameter
    mStrLen = Len(mText)
'Checking if the length of the value passed is not less than the minimum length and returning an appropriate Boolean value
    If Not mStrLen < mMinLen Then
        MinLen = True
    Else
        MinLen = False
    End If
End Function

'The ValidText() is called to validate whether the field value passed as a parameter contains anything other than alphabets
Public Function ValidTxt(mText As String) As Boolean
'Retrieving the length of the string passed as a parameter
    mStrLen = Len(mText)
'Looping through value passed as a parameter to scan for anything other than alphabets
    For mPosition = 1 To mStrLen
    'Retrieve each character from the string 'mStrCheck1'
        mStrCheck1 = Mid(mText, mPosition, 1)
    'Checking if the character retrieved is anything other than alphabets and returning an appropriate Boolean value
        If (Asc(mStrCheck1) < 65 And Not Asc(mStrCheck1) = 39) Or (Asc(mStrCheck1) > 90 And Asc(mStrCheck1) < 97) Or Asc(mStrCheck1) > 122 Then
            ValidTxt = False
            Exit Function
        Else
            ValidTxt = True
        End If
    Next
End Function
'********** FUNCTIONALITY FOR FORM FIELD VALIDATIONS ENDS **********
'*******************************************************************


'*******************************************************************
'****** FUNCTIONALITY FOR APPLICATION's OTHER FEATURES BEGINS ******
'The ConvertAmt() is called to return a textual form for the digits passed as a parameter
Public Function ConvertAmt(ByVal mInt As String) As String
    mStr = ""
    mInt = Trim(Str(mInt))
    mStrLen = Len(mInt)
'Creating an iterated process to scan each digit of the parameter's value
    For mPosition = 2 To mStrLen
    'Checking if the current digit being scanned is not a zero or a dot symbol
        If Mid(mInt, mPosition, 1) <> 0 Or mPosition = 9 Then
        'Checking for the digit's position in the parameter to concatenate a string accordingly
            If mPosition = 2 Or mPosition = 4 Or mPosition = 7 Or mPosition = 10 Then
                Select Case Mid(mInt, mPosition, 1)
                Case "1"
                    If Mid(mInt, mPosition + 1, 1) = 0 Or (mPosition = mStrLen) Then
                        mStr = mStr & "Ten "
                    End If
                Case "2"
                    mStr = mStr & "Twenty "
                Case "3"
                    mStr = mStr & "Thirty "
                Case "4"
                    mStr = mStr & "Forty "
                Case "5"
                    mStr = mStr & "Fifty "
                Case "6"
                    mStr = mStr & "Sixty "
                Case "7"
                    mStr = mStr & "Seventy "
                Case "8"
                    mStr = mStr & "Eighty "
                Case "9"
                    mStr = mStr & "Ninety "
                End Select
            End If
            If ((mPosition = 3 Or mPosition = 5 Or mPosition = 8 Or mPosition = 11) And (Not Mid(mInt, mPosition - 1, 1) = 1)) Or mPosition = 6 Then
                Select Case Mid(mInt, mPosition, 1)
                Case "1"
                    mStr = mStr & "One "
                Case "2"
                    mStr = mStr & "Two "
                Case "3"
                    mStr = mStr & "Three "
                Case "4"
                    mStr = mStr & "Four "
                Case "5"
                    mStr = mStr & "Five "
                Case "6"
                    mStr = mStr & "Six "
                Case "7"
                    mStr = mStr & "Seven "
                Case "8"
                    mStr = mStr & "Eight "
                Case "9"
                    mStr = mStr & "Nine "
                End Select
            ElseIf (Mid(mInt, mPosition - 1, 1) = 1) And (Not mPosition = 2) Then
                Select Case Mid(mInt, mPosition, 1)
                Case "1"
                    mStr = mStr & "Eleven "
                Case "2"
                    mStr = mStr & "Twelve "
                Case "3"
                    mStr = mStr & "Thirteen "
                Case "4"
                    mStr = mStr & "Fourteen "
                Case "5"
                    mStr = mStr & "Fifteen "
                Case "6"
                    mStr = mStr & "Sixteen "
                Case "7"
                    mStr = mStr & "Seventeen "
                Case "8"
                    mStr = mStr & "Eighteen "
                Case "9"
                    mStr = mStr & "Nineteen "
                End Select
            End If
        End If
        Select Case mPosition
        Case 3
            If Mid(mInt, 2, 2) <> 0 Then
                mStr = mStr & "Lakh "
            End If
        Case 5
            If Mid(mInt, 4, 2) <> 0 Then
                mStr = mStr & "Thousand "
            End If
        Case 6
            If Mid(mInt, 6, 1) <> 0 Then
                mStr = mStr & "Hundred "
            End If
        Case 9
            If Mid(mInt, 10, 2) <> 0 Then
                mStr = mStr & "And "
            End If
        End Select
    Next
'Checking if the length of the parameter exceeds 9 characters
    If mStrLen > 9 Then
        mStr = mStr & "Paise "
    End If
'Returning a concatenated string
    ConvertAmt = mStr & "Only"
End Function

'The GetActvRs() is called to returns an appropriate ADODB's Recordset object for the parameter string passed
Public Function GetActvRs(ByVal mFrmRs As String) As ADODB.Recordset
'Checking the value of the variable 'mFrmRs', by using the 'Select Case' statement, to determine an action
    Select Case mFrmRs
    Case Is = "gAcctRs" 'If the variable holds 'gAcctRs'
    'Returning the ADODB's Recordset object for Account Master
        Set GetActvRs = gAcctRs
    Case Is = "gClntRs" 'If the variable holds 'gClntRs'
    'Returning the ADODB's Recordset object for Client Master
        Set GetActvRs = gClntRs
    Case Is = "gEmpRs" 'If the variable holds 'gEmpRs'
    'Returning the ADODB's Recordset object for Employee Master
        Set GetActvRs = gEmpRs
    Case Is = "gTransRs" 'If the variable holds 'gTransRs'
    'Returning the ADODB's Recordset object for Transaction Master
        Set GetActvRs = gTransRs
    End Select
End Function

'The GetAcctType() is called to return an account type by passed an account number
Public Function GetAcctType(mIdNo As Integer) As String
'Creating an SQL query string to retrieve the Account Type field from the Account's Master table
    gTemp1Sql = "SELECT AcctType FROM Acct_Mstr Where AcctNo = " & mIdNo
'Opening a temporary ADODB's Recordset by passing the SQL query and other parameters
    gTemp3Rs.Open gTemp1Sql, gConnect, adOpenKeyset, adLockPessimistic
'Storing the Account Type into a variable
    mStr = gTemp3Rs.Fields(0)
'Closing the temporary ADODB's recordset
    gTemp3Rs.Close
'Returning the Account Type
    GetAcctType = mStr
End Function

'The GetIdentity() is called to return a client's full name by passed a table name and an Id number
Public Function GetIdentity(mTable As String, mIdNo As Integer) As String
'Creating an SQL query string to retrieve fields from the Client's Master table
    If mTable = "Clnt_Mstr" Then
        mStr = "SELECT ClientId, FName, MName, LName, DOB FROM Clnt_Mstr Where ClientId = " & mIdNo
    Else
        mStr = "SELECT EmpId, FName, MName, LName, DOB FROM Emp_Mstr Where EmpId = " & mIdNo
    End If
'Opening a temporary ADODB's Recordset by passing the SQL query and other parameters
    gTemp3Rs.Open mStr, gConnect, adOpenKeyset, adLockPessimistic
'Storing the concatenated Client's full name into a variable
    mStr = gTemp3Rs.Fields(0) & "-" & gTemp3Rs.Fields(1) & " " & gTemp3Rs.Fields(2) & " " & gTemp3Rs.Fields(3) & " - " & Format(gTemp3Rs.Fields(4), "dd/mm/yyyy")
'Closing the temporary ADODB's recordset
    gTemp3Rs.Close
'Returning the concatenated Client's full name
    GetIdentity = mStr
End Function

'The GetNumber() is called to return a person's identity number
Public Function GetNumber(mStr As String) As Integer
'Getting the position of the hyphen (-) in the selected client's name
    mPosition = InStr(1, mStr, "-", vbTextCompare)
'Returning the Client's Id number from the selected client's name
    GetNumber = Mid(mStr, 1, mPosition - 1)
End Function

'The PopNameCmb() is called to populate the combo box listing client's name
Public Function PopNameCmb(ByVal mSql As String, mStr As String, mCmb As ComboBox) As String
'Clearing the option list held in the combo box
    mCmb.Clear
'Opening the ADODB's Recordset object used for retrieving records
    gTemp2Rs.Open mSql, gConnect, adOpenKeyset, adLockPessimistic
'Checking if the active recordset contains records
    If gTemp2Rs.RecordCount > 0 Then
    'Displaying a client's name in the combo box passed as a parameter
        mCmb.Text = GetIdentity(mStr, gTemp2Rs.Fields(0))
        If gTemp2Rs.Fields.Count = 3 Then
            For mPosition = 0 To 2
                If gTemp2Rs.Fields(mPosition) > 0 Then
                    mCmb.AddItem (GetIdentity(mStr, gTemp2Rs.Fields(mPosition)))
                End If
            Next
        Else
            Do While Not gTemp2Rs.EOF
                mCmb.AddItem (GetIdentity(mStr, gTemp2Rs.Fields(0)))
                gTemp2Rs.MoveNext
            Loop
        End If
    End If
'Closing the active recordset
    gTemp2Rs.Close
'Returning the value displayed on the combo box
    PopNameCmb = mStr
End Function

'The PopNoCmb() is called to populate a combo box passed a parameter
Public Function PopNoCmb(mStr As String, mCmb As ComboBox) As String
'Clearing the option list held in the combo box
    mCmb.Clear
'Creating a SQL query string to retrieve all Account number for a specific account type
    mStr = "SELECT AcctNo FROM Acct_Mstr Where AcctType = '" & mStr & "'"
'Opening the ADODB's Recordset object used for retrieving records
    gTemp2Rs.Open mStr, gConnect, adOpenKeyset, adLockPessimistic
'Checking if the active recordset contains records
    If gTemp2Rs.RecordCount > 0 Then
    'Displaying the first account number in the combo box passed as parameter
        mCmb.Text = gTemp2Rs.Fields(0)
    'Checking if the recordset's cursor has moved beyond the LAST record in the recordset
        Do While Not gTemp2Rs.EOF
        'Adding an item to the combo box passed as parameter
            mCmb.AddItem (gTemp2Rs.Fields(0))
        'Placing the active recordset's cursor on the Next record
            gTemp2Rs.MoveNext
        Loop    'End of 'Do While ... Loop' iteration
    End If
'Closing the active recordset
    gTemp2Rs.Close
'Returning the value displayed on the combo box
    PopNoCmb = mStr
End Function

'The ReturnId() is called to display a person's name in a form field passed as parameters
Public Sub ReturnId(mVal As String, ByVal mFrmFld As String)
'Checking the value of the variable 'mFrmFld', using the 'Select Case' statement, to decide on a form field for displaying the first parameter
    Select Case mFrmFld
    Case Is = "frmAcctMstr.txtHldrName(0)" 'If the variable holds 'frmAcctMstr.txtHldrName(0)'
        frmAcctMstr.txtHldrName(0).Text = mVal
    Case Is = "frmAcctMstr.txtHldrName(1)" 'If the variable holds 'frmAcctMstr.txtHldrName(0)'
        frmAcctMstr.txtHldrName(1).Text = mVal
    Case Is = "frmAcctMstr.txtHldrName(2)" 'If the variable holds 'frmAcctMstr.txtHldrName(0)'
        frmAcctMstr.txtHldrName(2).Text = mVal
    Case Is = "frmAcctMstr.txtNomiName" 'If the variable holds 'frmAcctMstr.txtNomiName'
        frmAcctMstr.txtNomiName.Text = mVal
    Case Is = "frmAcctMstr.txtNomiName" 'If the variable holds 'frmAcctMstr.txtNomiName'
        frmAcctMstr.txtNomiName.Text = mVal
    End Select
End Sub
'******* FUNCTIONALITY FOR APPLICATION's OTHER FEATURES ENDS *******
'*******************************************************************

'*******************************************************************
'******** FUNCTIONALITY FOR MDI's OTHER SUBROUTINES BEGINS *********
'The DisableFrmOpt() is called to disable the MDI's sub menu options used to open a child form
Public Sub DisableFrmOpt()
'Disabling the sub menu options used to open a data entry form
    frmMain.mnuAcctMstr.Enabled = False
    frmMain.mnuClntMstr.Enabled = False
    frmMain.mnuEmpMstr.Enabled = False
    frmMain.mnuTransMstr.Enabled = False
'Disabling the sub menu options used to open a report generating form
    frmMain.mnuPassBk.Enabled = False
    frmMain.mnuStmt.Enabled = False
End Sub

'The DisableMstrNvgt() is called to disable the data entry form's navigation options
Public Sub DisableMstrNvgt()
'Disabling the sub menu options used for data navigation
    frmMain.mnuFrst.Enabled = False
    frmMain.mnuPrev.Enabled = False
    frmMain.mnuNext.Enabled = False
    frmMain.mnuLast.Enabled = False
'Disabling the toolbar buttons used for data navigation
    frmMain.cmdFrst.Enabled = False
    frmMain.cmdPrior.Enabled = False
    frmMain.cmdNext.Enabled = False
    frmMain.cmdLast.Enabled = False
End Sub

'The EnabledMstrNvgt() is called to enable the data entry form's navigation options
Public Sub EnableMstrNvgt()
'Enabling the sub menu options used for data navigation
    frmMain.mnuFrst.Enabled = True
    frmMain.mnuPrev.Enabled = True
    frmMain.mnuNext.Enabled = True
    frmMain.mnuLast.Enabled = True
'Enabling the toolbar buttons used for data navigation
    frmMain.cmdFrst.Enabled = True
    frmMain.cmdPrior.Enabled = True
    frmMain.cmdNext.Enabled = True
    frmMain.cmdLast.Enabled = True
End Sub

'The AddQuote() is called to returns a variable string passed as a parameter after replacing one single quote with two single quotes
Public Function AddQuote(mString As String)
'Calling the VB's Replace() function to replace one single quote character with two single quote characters
    AddQuote = Replace(mString, "'", "''")
End Function

'********* FUNCTIONALITY FOR MDI's OTHER SUBROUTINES ENDS **********
'*******************************************************************


'*******************************************************************
'************* SUBROUTINES BASED ON TRUTH TABLE BEGINS *************
'The NoMode() is called to determine the state of the MDI's menubar and toolbar such as to allow Insert or View operations only
Public Sub NoMode()
'Calling DisableFrmOpt() to disable the MDI's sub menu options used to open a child form
    Call DisableFrmOpt
'Enabling sub menu options used to deactivate a form
    frmMain.mnuExit.Enabled = True
'Enabling or disabling sub menu options used for data manipulation
    frmMain.mnuInst.Enabled = True
    frmMain.mnuUpdt.Enabled = False
    frmMain.mnuDel.Enabled = False
    frmMain.mnuPrnt.Enabled = False
    frmMain.mnuSave.Enabled = False
    frmMain.mnuView.Enabled = True
'Enabling or disabling toolbar buttons used for data manipulation
    frmMain.cmdInst.Enabled = True
    frmMain.cmdUpdt.Enabled = False
    frmMain.cmdDel.Enabled = False
    frmMain.cmdView.Enabled = True
    frmMain.cmdPrnt.Enabled = False
    frmMain.cmdSave.Enabled = False
    frmMain.cmdExit.Enabled = True
'Call DisableMstrNvgt to disable navigation options
    Call DisableMstrNvgt
'Calling DisableFrmFlds to disable data entry form fields
    Call GetActvFrm(gFrmName1).DisableFrmFlds
End Sub

'The ChngMstr() is called to determine the state of the MDI's menubar and toolbar such as to allow data manipulation and navigation operations only
Public Sub ChngMstr()
'Enabling or disabling sub menu options used for data manipulation
    frmMain.mnuInst.Enabled = True
    frmMain.mnuUpdt.Enabled = True
    frmMain.mnuDel.Enabled = True
    frmMain.mnuPrnt.Enabled = True
    frmMain.mnuSave.Enabled = False
'Enabling or disabling toolbar buttons used for data manipulation
    frmMain.cmdInst.Enabled = True
    frmMain.cmdUpdt.Enabled = True
    frmMain.cmdDel.Enabled = True
    frmMain.cmdView.Enabled = False
    frmMain.cmdPrnt.Enabled = True
    frmMain.cmdSave.Enabled = False
    frmMain.cmdExit.Enabled = True
'Calling EnableMstrNvgt to enabling navigation options
     Call EnableMstrNvgt
'Calling DisableFrmFlds to disable data entry form fields
    Call GetActvFrm(gFrmName1).DisableFrmFlds
End Sub

'The SaveMstr() is called to determine the state of the MDI's menubar and toolbar such as to allow only the Save operation
Public Sub SaveMstr()
'Enabling or disabling sub menu options used for data manipulation
    frmMain.mnuInst.Enabled = False
    frmMain.mnuUpdt.Enabled = False
    frmMain.mnuDel.Enabled = False
    frmMain.mnuPrnt.Enabled = False
    frmMain.mnuSave.Enabled = True
    frmMain.mnuView.Enabled = False
'Enabling or disabling toolbar buttons used for data manipulation
    frmMain.cmdInst.Enabled = False
    frmMain.cmdUpdt.Enabled = False
    frmMain.cmdDel.Enabled = False
    frmMain.cmdView.Enabled = False
    frmMain.cmdPrnt.Enabled = False
    frmMain.cmdSave.Enabled = True
'Checking if another data entry form is active in the background
    If gFrmName2 = "" Then
        frmMain.cmdExit.Enabled = True
    End If
'Calling DisableMstrNvgt to disable navigation options
    Call DisableMstrNvgt
'Checking if the variable 'gFrmName1' is not empty
    If gFrmName1 <> "" Then
    'Calling EnableFrmFlds to enable data entry form fields
        Call GetActvFrm(gFrmName1).EnableFrmFlds
    End If
End Sub
'************** SUBROUTINES BASED ON TRUTH TABLE ENDS **************
'*******************************************************************
